Index: code/trunk/data/levels/BumpMap.oxw
===================================================================
--- code/trunk/data/levels/BumpMap.oxw	(revision 12291)
+++ code/trunk/data/levels/BumpMap.oxw	(revision 12292)
@@ -60,12 +60,5 @@
     <Model position="0, 12,0" yaw="90" pitch="-90" roll="0" scale="10" mesh="Cube_Lava_V2.mesh" />
     <Model position="0, -12,0" yaw="90" pitch="-90" roll="0" scale="10" mesh="Cube_Lava_V2_Normal.mesh" />
-
     -->
-     
-    s<MovableEntity position="0,0,40" rotationrate="30" rotationaxis="1,0,1">
-      <attached>
-          <Model position="0, 0,0" yaw="90" pitch="-90" roll="0" scale="10" mesh="Gravestone.mesh" />
-      </attached>
-    </MovableEntity>
 
     <MovableEntity position="0,0,40" rotationrate="30" rotationaxis="1,0,1">
Index: code/trunk/data/levels/templates/spaceshipHover.oxt
===================================================================
--- code/trunk/data/levels/templates/spaceshipHover.oxt	(revision 12291)
+++ code/trunk/data/levels/templates/spaceshipHover.oxt	(revision 12292)
@@ -22,5 +22,5 @@
    rotationThrust    = 25
 
-   jumpBoost = 180
+   jumpBoost = 90
 
    lift = 1;
Index: code/trunk/src/modules/hover/Hover.cc
===================================================================
--- code/trunk/src/modules/hover/Hover.cc	(revision 12291)
+++ code/trunk/src/modules/hover/Hover.cc	(revision 12292)
@@ -53,5 +53,4 @@
 
         this->setHUDTemplate("HoverHUD");
-
     }
 
@@ -113,5 +112,4 @@
         }
         numberOfFlags_ = flags_.size();
-
     }
 }
Index: code/trunk/src/modules/hover/HoverShip.cc
===================================================================
--- code/trunk/src/modules/hover/HoverShip.cc	(revision 12291)
+++ code/trunk/src/modules/hover/HoverShip.cc	(revision 12292)
@@ -33,5 +33,4 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "graphics/Camera.h"
 
 #include <BulletCollision/NarrowPhaseCollision/btManifoldPoint.h>
@@ -46,27 +45,15 @@
         enableCollisionCallback();
         isFloor_ = false;
-        jumpBoost_ = 0;    
+        jumpBoost_ = 0;
     }
 
     void HoverShip::moveFrontBack(const Vector2& value)
-        { this->steering_.z -= value.x; 
-            Vector3 currentPosition = this->getPosition();
-            currentPosition.y -= 2*value.y;
-            this->setPosition(currentPosition);
-        }
+        { this->steering_.z -= value.x; }
 
     void HoverShip::moveRightLeft(const Vector2& value)
-        { 
-            this->steering_.x += value.x; 
-            Vector3 currentPosition = this->getPosition();
-            currentPosition.x -= 2*value.x;
-            this->setPosition(currentPosition);
-        }
+        { this->steering_.x += value.x; }
 
     void HoverShip::moveUpDown(const Vector2& value)
-        { 
-            this->steering_.y += value.x; 
-            this->setPosition(Vector3(0, 0, 0));
-        }
+        { this->steering_.y += value.x; }
 
     void HoverShip::rotateYaw(const Vector2& value)
@@ -82,21 +69,4 @@
 
         XMLPortParam(HoverShip, "jumpBoost", setJumpBoost, getJumpBoost, xmlelement, mode);
-    }
-
-    void HoverShip::tick(float dt)
-    {
-        SUPER(HoverShip, tick, dt);
-                //Execute movement
-        if (this->hasLocalController())
-            {
-             // Camera
-            Camera* camera = this->getCamera();
-            if (camera != nullptr)
-            {
-                camera->setPosition(0,1000,0);
-                camera->setOrientation(Vector3::UNIT_X, Degree(-90));
-
-            }
-        }
     }
 
Index: code/trunk/src/modules/hover/HoverShip.h
===================================================================
--- code/trunk/src/modules/hover/HoverShip.h	(revision 12291)
+++ code/trunk/src/modules/hover/HoverShip.h	(revision 12292)
@@ -69,6 +69,4 @@
             virtual void boost(bool bBoost) override;
 
-            virtual void tick(float dt) override;
-
         private:
             float jumpBoost_;